#include <stdio.h>

int n, m;
char cifre[10];
int stanga[1000000];
int dreapta[1000000];

FILE *Fin, *Fout;

void genereaza( int i, int rest)
{
   if( 2*i < n )
     {
       for( cifre[i] = 0; cifre[i] < 10; ++cifre[i] )
         genereaza( i+1, (rest*10 + cifre[i]) % m );
     }
   else
     if( i < n )
       {
         cifre[i] = cifre[n-i-1];
         genereaza( i+1, (rest*10 + cifre[i]) % m );
       }
     else
       {
         if( cifre[0] != 0 )
           stanga[rest] += 1;
         dreapta[rest] += 1;
       }
}

int main( void )
{
  int L, D, i;
  
  Fin = fopen("bipal.in", "r");
  fscanf(Fin, "%d %d", &n, &m ); 
  n /= 2;

  genereaza( 0, 0 );

  long long ret = 0;
  for( L = 0; L < m; ++L )
    {
      D = m-L;
      for( i = 0; i < n; ++i ) D = (D*10) % m;

      ret += (long long)stanga[L] * dreapta[D];
    }
  Fout = fopen("bipal.out", "w");
  fprintf(Fout,  "%lld\n",  ret );
  fclose(Fout);

  return 0;
}
