program bipalin;

var i, n, m: longint;
    cifre: array[0..9] of integer;
    stanga, dreapta: array[0..999999] of longint; {resturile care se pot}
    L, D: longint;     {obtine la impartirea cu m pentru palindromul din }
    ret: Int64;      {stanga, respectiv dreapta}
    Fin, Fout: Text;
        
procedure generare( i, rest: longint );
var z: integer;
begin
  if 2*i < n then          {daca nu am pus inca N/4 cifre}
    begin
      for z := 0 to 9 do       {pun pe rand pe pozitia i cifrele 0..9 }
        begin
          cifre[i] := z;
          generare( i+1, (rest*10 + cifre[i]) mod m );  {apel recursiv pentru pozitia i+1}
        end;                                            {cu calcularea si transmiterea mai departe}
    end                                                 {a restului obtinut pana aici}
  else                    {altfel ... am deja N/4 cifre}
    if i < n then            {daca nu sunt inca la cifra din mijlocul palidromului, daca exista!!!}
      begin
        cifre[i] := cifre[n-i-1];                    {construiesc partea a doua a palindromului - oglinda}
        generare( i+1, (rest*10 + cifre[i]) mod m ); {apel recursiv pentru pozitia i+1}
      end
    else                     {altfel ... gata palindromul}
      begin
        if cifre[0] <> 0 then               {daca nu incepe cu 0 e bun si in stanga}
          stanga[rest] := stanga[rest] + 1;    {deci se poate obtine restul "rest" la impartire cu m}
        dreapta[rest] := dreapta[rest] + 1; {in dreapta e bun oricum - s-a obtinut restul "rest"}
     end;
end;

begin
  Assign(Fin, 'bipal.in'); Reset(Fin);
  Assign(Fout, 'bipal.out'); ReWrite(Fout);
  readln(Fin, n, m );
  n := n div 2;             {un palindrom are n/2 cifre}

  generare( 0, 0 );         {generez recursiv palindroamele}

  ret := 0;
  for L := 0 to m-1 do      {pentru fiecare rest posibil a primului palindrom cel din stanga}
    begin
      D := m-L;             {calculam restul din dreapta}
      for i := 1 to n do
        D := (D*10) mod m;

      ret := ret + int64(stanga[L]) * int64(dreapta[D]);  {se adauga la rezultat}
    end;
  writeln(Fout, ret );
  Close(Fout);
end.
